SystemOrganization addCategory: #DeutschByte!

Object subclass: #BlockWithExit
	instanceVariableNames: 'block exitBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeutschByte'!

!BlockWithExit class methodsFor: 'testing' stamp: 'jjddpp 10/7/2012 22:39'!
example
	"BlockWithExit example"
	"Tenim una nova classe BlockWithExit amb quatre mtodes (amb 1, 1, 2 i 1 linia de codi respectivament).
Tamb afegim un mtode nou a BlockClosure dins el protocol *BlockWithExit (que t 1 lnia de codi).
Pregunta: 
Investigueu per a qu serveix la classe BlockWithExit. Un exemple de la seva utilitzaci s al Workspace (heu d'analitzar un total de 6 lnies noves de codi)"

| theLoop coll |
Transcript open.
coll := OrderedCollection new.
1000 timesRepeat: [ coll add: 1000 atRandom ].
theLoop := [coll do: [:each | Transcript show: each asString; cr.
							  (each < 100) ifTrue: [theLoop exit]]] withExit.
theLoop value.
! !

!BlockWithExit class methodsFor: 'instance creation' stamp: 'jjddpp 10/7/2012 22:20'!
with: aBlock
	^ self new with: aBlock ! !

!BlockWithExit methodsFor: 'control' stamp: 'jjddpp 10/7/2012 22:19'!
exit
	exitBlock value! !

!BlockWithExit methodsFor: 'control' stamp: 'jjddpp 10/7/2012 22:19'!
value
	exitBlock := [^ nil].
	^ block value.
! !

!BlockWithExit methodsFor: 'initialize-release' stamp: 'jjddpp 10/7/2012 22:19'!
with: aBlock
	block := aBlock ! !

!BlockClosure methodsFor: '*DeutschByte' stamp: 'jjddpp 10/7/2012 22:22'!
withExit
	^ BlockWithExit with: self! !

!Symbol methodsFor: '*DeutschByte' stamp: 'jjddpp 10/7/2012 22:16'!
bindTo: value in: aBlock 
	^ Binding of: self to: value in: aBlock 
	! !

!Symbol methodsFor: '*DeutschByte' stamp: 'jjddpp 10/7/2012 22:16'!
binding
	| context |
	context := thisContext.
	[ context = nil ] whileFalse:
		[   ((context receiver isMemberOf: Binding)
				and: [ context selector = #of:to:in:
					and: [context receiver key = self]])
				ifTrue: [^ context receiver value]
				ifFalse: [context := context sender]
		].
	self error: 'No binding for ', self asString.! !

Association subclass: #Binding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeutschByte'!

!Binding class methodsFor: 'testing' stamp: 'jjddpp 10/7/2012 22:36'!
exampleSuccessful
	"Binding exampleSuccessful"

	#testingDynamicBinding bindTo: 'This is a test' in: 
		[ Transcript show: (#testingDynamicBinding binding) asString; cr. ] .! !

!Binding class methodsFor: 'testing' stamp: 'jjddpp 10/7/2012 22:36'!
exampleUnsuccessful
	"Binding exampleUnsuccessful"

	#testingDynamicBinding bindTo: 'This is a test' in: 
	[ Transcript show: (#testingDynamikBinding binding) asString; cr. ] .! !

!Binding class methodsFor: 'instance creation' stamp: 'jjddpp 10/7/2012 22:13'!
of: aSymbol to: aValue in: aBlock
	^ self new of: aSymbol to: aValue in: aBlock ! !

!Binding methodsFor: 'initialize-release' stamp: 'jjddpp 10/7/2012 22:13'!
of: aSymbol to: aValue in: aBlock
	key := aSymbol.
	value := aValue.
	^ aBlock value! !
